package ch.zhaw.projekt2.turnierverwaltung;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public class FileIO {
    File saveDir;
    File saves;


    public FileIO() {
        String savePath = System.getProperty("user.dir") + File.separator + "tournierverwaltung_angrynerds";
        this.saveDir = new File(savePath);
        saveDir.mkdir();
        saves = new File(saveDir, "saves");
        saves.mkdir();
    }

    public List<File> getList() {
        return Arrays.asList(saves.listFiles());
    }

    public Tournament loadTournament(File tournamentFile) {
        Tournament tournament;
        try {
            ObjectInputStream in = new ObjectInputStream(new FileInputStream(tournamentFile));
            tournament = (Tournament) in.readObject();
            in.close();

        } catch (ClassNotFoundException | IOException e) {
            throw new RuntimeException(e);
        }

        return tournament;
    }

    public void saveTournament(Tournament tournament) {
        File newSave = new File(saves, tournament.getName() + ".txt");
        try {
            newSave.createNewFile();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(newSave));
            out.writeObject(tournament);
            out.close();
            System.out.println("Save File" + tournament.getName() + ".txt being saved to " + saves.getAbsolutePath());

        } catch (IOException e) {
            e.printStackTrace();
        }

    }
}
